/*
 * COMMUNICATION.c
 *
 * 
 *
 * Based on the original PGM 
 * Created: 24.04.2013 23:03:35
 *  Author: jens
 *
 * Modified and adapted to fit into programm by
 * Hartmut Burger 
 * 01.10.2014
 */

#include "init.h"
#include "ProtocollData.h"

#include <avr/io.h>
#include <avr/interrupt.h>

int getBusy = 0;
int putBusy = 0;
int batBusy = 0;				


void Communication(int getComm , int putComm , int batComm){
   cli();																				// disable all interrupts
   
  /* while(getComm == 0  )																// Repeat loop until Transmission completed //
   {    
	  
	  if (putBusy == 0 || batBusy == 0)
	  {
	  getBusy = 1;  
	  USART_ReceiveByte();																// get the propper Sign from the Frontboard /
	  prot_code_FAULT_receicve= UDR0;
	  
	  if (prot_code_FAULT_receicve == prot_BEGIN );USART_SendByte(prot_ACK);			// if "protbegin" received from Frontboard //
					 																					
	  if (prot_code_FAULT_receicve == prot_Send_Data );USART_SendByte(prot_Receive_Data);
		
	  if (prot_code_FAULT_receicve == prot_gen_FAULT);USART_SendByte(prot_Receive_Data);FaultHandler(prot_code_FAULT_receicve,0);								// indicates any fault  on the FRONTBOARD or on MAINBOARD ( blinkcode informs about the fault)
	 
	  if (prot_code_FAULT_receicve == prot_batt_FAULT);USART_SendByte(prot_Receive_Data);FaultHandler(prot_code_FAULT_receicve,0);							// BATTERIE FAULT on the FRONTBOARD ( blinkcode informs about the fault)
	 
	  if (prot_code_FAULT_receicve == prot_button_Red);USART_SendByte(prot_Receive_Data);RedButton = 1;
	  
	  if (prot_code_FAULT_receicve == prot_button_Green);USART_SendByte(prot_Receive_Data);GreenButton = 1;
	  
	  if (prot_code_FAULT_receicve >= 230 && prot_code_FAULT_receicve <= 239 );USART_SendByte(prot_Receive_Data);FaultHandler(prot_code_FAULT_receicve,0);	// Fault codes between 10 and 20 allowed FAULT FROM MAIN or FRONTBOARD 
							
	  if (prot_code_FAULT_receicve < 230 || prot_code_FAULT_receicve > 254 );USART_SendByte(prot_Receive_Break);getComm =1;getBusy=0;
	  
	  if (prot_code_FAULT_receicve == prot_Endof_Transmit );getComm =1;getBusy=0;
	  
	  prot_code_FAULT_receicve = 0;
	  }
   }
	
	
	
	while(putComm == 0 )																// Repeat loop until Transmission completed //
	{
		if (getBusy == 0 || batBusy ==0)
		{
		
		if (putBusy == 0);USART_SendByte(prot_BEGIN);putBusy = 1;
		
		USART_ReceiveByte();															// send the Prot begin Sign to Frontboard /
		prot_code_FAULT_receicve= UDR0;
		
		if (prot_code_FAULT_receicve == prot_ACK );USART_SendByte(prot_Send_Data);		// if "protbegin" received from Frontboard //
		
		if (prot_code_FAULT_receicve == prot_Receive_Data);USART_SendByte(prot_code_FAULT_send);USART_SendByte(prot_Endof_Transmit);putComm =1;putBusy=0;	
		
		if (prot_code_FAULT_receicve == prot_Receive_Break);putComm =1;putBusy=0;
		
		prot_code_FAULT_receicve = 0;
		prot_code_FAULT_send = 0;
		}
																																										
	}
	
	while(batComm == 0 )																// Repeat loop until Transmission completed //
	{
		if (getBusy == 0 || putBusy ==0 )
		{
			
			if (batBusy == 0);USART_SendByte(prot_BEGIN);batBusy = 1;
			
			USART_ReceiveByte();															// send the Prot begin Sign to Frontboard /
			prot_code_FAULT_receicve= UDR0;
			
			if (prot_code_FAULT_receicve == prot_ACK );USART_SendByte(prot_Send_Data);		// if "protbegin" received from Frontboard //
			
			if (prot_code_FAULT_receicve == prot_Receive_Data && chargSTART == 1);USART_SendByte(prot_charg_START);USART_SendByte(prot_Endof_Transmit);batComm =1;batBusy=0;
			
			if (prot_code_FAULT_receicve == prot_Receive_Data && chargSTOP == 1);USART_SendByte(prot_charg_STOP);USART_SendByte(prot_Endof_Transmit);batComm =1;batBusy=0;
			
			if (prot_code_FAULT_receicve == prot_Receive_Data && chargBUSY == 1);USART_SendByte(prot_charg_BUSY);USART_SendByte(prot_Endof_Transmit);batComm =1;batBusy=0;
			
			if (prot_code_FAULT_receicve == prot_Receive_Break);batComm =1;batBusy=0;
			
			prot_code_FAULT_receicve = 0;
		}
		
	} */
sei();																					// enable all interrupts																					
}