/*
 * kitchen_mainboard.c
 *
 * Created: 23.09.2014 19:39:05
 *  Author: Hartmut_Dell
 */ 

#define F_CPU 8000000UL
#include <util/delay.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include "ProtocollData.h"
#define C_MAIN
#include "init.h"
#include "schedule.h"
#include <stdbool.h>

void Motor(void)
{
	MotorLinksON;
	_delay_ms(200);
	MotorLinksOFF;
	_delay_ms(200);
	
}




int main(void)
{
 
initialSequence(0);												// start the INIT PGM to RUN STARTUP SEQUENCE 

	
/***************************** SCHEDULER INITALISIEREN **********************************************/	
	
	TCNT1L=0x00;
	TCNT1H=0x00;
	// lets turn on 16 bit timer1 also with /256
	TCCR1B |=  (1 << CS12);	  //(1 << CS10) |
	TIMSK1=(1<<TOIE1);
	timerinit();
	sei();
/***************************** PROGRAMMABLAUFSTEUERUNG **********************************************/	
	 
    for (;;)
    {
      
		  if( f_timer_tick ){						// Scheduler im Hintergrund ablaufen lassen
		  f_timer_tick = 0;
		  timertick(); 
		  }
		 
			if(timerremove(Motor));timeradd( Motor, SECONDS( 3 ) ); 
			
	}
}